Summary: Bridge from Nagios to the MSG Messaging system
Name: msg-nagios-bridge
Version: 1.1.0
Release: 1%{?dist}
License: APL2
Group: Network/Monitoring
Source: %{name}-%{version}.src.tgz
BuildRoot: %{_tmppath}/%{name}-%{version}-build
BuildArch: noarch
Requires: perl(GridMon) >= 1.0.70
Requires: msg-utils
Requires: perl(No::Worries)

%description

%prep
%setup -c

%build

%install
rm -rf %{buildroot}
make prefix=%{buildroot} install

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
/usr/libexec/grid-monitoring/plugins/nagios/eventhandlers/handle_service_check
/usr/libexec/grid-monitoring/plugins/nagios/eventhandlers/handle_service_change
/usr/libexec/grid-monitoring/plugins/nagios/send_to_msg
/usr/libexec/grid-monitoring/plugins/nagios/recv_from_queue
/usr/libexec/grid-monitoring/plugins/nagios/check_config
/usr/sbin/msg-clean-spool
/usr/sbin/msg-to-handler
/usr/sbin/msg-to-handler.chk
/usr/sbin/nagios-notifications
/usr/sbin/send-to-dashboard
/etc/init.d/msg-to-handler
/etc/init.d/send-to-dashboard
/etc/cron.hourly/msg-to-handler.chk
/etc/cron.d/send-to-dashboard
%config /etc/sysconfig/msg-to-queue
%config /etc/sysconfig/msg-to-handler
%config %attr(0644,nagios,nagios) /var/cache/msg/config-cache/config.db
%config %attr(0644,root,root) /etc/msg-to-handler.conf
%dir /etc/msg-to-handler.d
%dir %attr(0770,nagios,nagios) /var/cache/msg/config-cache
%dir %attr(0770,nagios,nagios) /var/run/msg-to-handler
%dir %attr(0770,nagios,nagios) /var/spool/msg-nagios-bridge/outgoing
%dir %attr(0770,nagios,nagios) /var/spool/msg-nagios-bridge/incoming
%dir %attr(0770,nagios,nagios) /var/spool/msg-nagios-bridge/outgoing_alarms
%dir %attr(0770,nagios,nagios) /var/spool/msg-nagios-bridge/undelivered-messages
%dir %attr(0770,nagios,nagios) /var/spool/msg-nagios-bridge/ggus
%dir %attr(0770,nagios,nagios) /var/spool/msg-nagios-bridge/outgoing-messages
%doc %{_datadir}/doc/%{name}-%{version}/CHANGES
%doc %{_datadir}/doc/%{name}-%{version}/INSTALL
%doc %{_datadir}/doc/%{name}-%{version}/README

%pre
if ! /usr/bin/id nagios &>/dev/null; then
    /usr/sbin/useradd -r -m -d /var/log/nagios -s /bin/sh -c "nagios" nagios || \
        logger -t nagios/rpm "Unexpected error adding user \"nagios\". Aborting installation."
fi
if ! /usr/bin/getent group nagiocmd &>/dev/null; then
    /usr/sbin/groupadd nagiocmd &>/dev/null || \
        logger -t nagios/rpm "Unexpected error adding group \"nagiocmd\". Aborting installation."
fi

%post
/sbin/chkconfig --add msg-to-handler
/sbin/chkconfig --add send-to-dashboard
[ -x /usr/sbin/msg-clean-spool ] && /usr/sbin/msg-clean-spool >/dev/null 2>&1
if [ $1 = "2" ]; then
   /sbin/service msg-to-handler condrestart
fi
:

%preun
if [ "$1" = 0 ]; then
   /sbin/service msg-to-handler stop
   /sbin/chkconfig --del msg-to-handler
   /sbin/service send-to-dashboard stop
   /sbin/chkconfig --del send-to-dashboard
fi
:

%changelog
* Mon Nov 17 2014 Emir Imamagic <eimamagi@srce.hr> - 1.1.0-1%{?dist}
- Fixed nagios-notifications
  https://github.com/ARGOeu/sam-probes/issues/22
* Wed Mar 13 2013 Robert Veznaver <robert.veznaver@cern.ch> - 1.0.70-1%{?dist}
- Replaced rest of perl-TOM to perl-No-Worries
* Sun Mar 3 2013 Emir Imamagic <eimamagi@srce.hr> - 1.0.69-1%{?dist}
- SAM-3211 org.egee.SendToMsg CRITICAL
* Tue Jan 29 2013 Marian Babik <marian.babik@cern.ch> - 1.0.67-1%{?dist}
- Minor syntax fix in msg-to-handler
* Mon Jan 14 2013 Marian Babik <marian.babik@cern.ch> - 1.0.66-1%{?dist}
- SAM-3140 Remove perl-GridMon::GGUS dependency from msg-nagios-bridge
* Wed Nov 28 2012 Nikolai Klopov <nikolai.klopov@cern.ch> - 1.0.65-1%{?dist}
- SAM-3127 Remove perl::TOM from msg-nagios-bridge
* Tue Nov 27 2012 Marian Babik <marian.babik@cern.ch> - 1.0.64-2%{?dist}
- SAM-3093 perl(GridMon::GGUSOutput) is needed by package msg-nagios-bridge
* Mon Jun 25 2012 Christos Triantafyllidis <ctria@grid.auth.gr> - 1.0.64-1%{?dist}
- SAM-2444: Replaced perl-MIG with perl-Messaging-Message
* Wed Mar 28 2012 Emir Imamagic <eimamagi@srce.hr> - 1.0.63-1%{?dist}
- SAM-2575: Remove references to metric set
* Thu Aug 11 2011 Emir Imamagic <eimamagi@srce.hr> - 1.0.62-1%{?dist}
- SAM-1775: Add an option for suppressing messages for MSG in handle_service_check
* Thu Jun 30 2011 Emir Imamagic <eimamagi@srce.hr> - 1.0.61-1%{?dist}
- SAM-1674: Add cronjob for sending OK alarms to dashboard
* Thu Jun 30 2011 Emir Imamagic <eimamagi@srce.hr> - 1.0.60-1%{?dist}
- SAM-1671: Enable sending notifications for all services and filtering 
  based on Nagios status
* Wed May 11 2011 Lionel Cons <lionel.cons@cern.ch> - 1.0.59-1%{?dist}
- Ported to the new perl-MIG 0.7 API.
* Fri Dec 10 2010 James Casey <james.casey@cern.ch> - 1.0.58-3%{?dist}
- Create home dir for nagios if it isn't there
* Thu Dec  9 2010 James Casey <james.casey@cern.ch> - 1.0.58-2%{?dist}
- Removed rpm dep on nagios, and created nagios users if needed instead
* Thu Dec  9 2010 Lionel Cons <lionel.cons@cern.ch> - 1.0.58-1
- msg-to-handler now stores its pid file in /var/run/msg-to-handler/pid.
* Tue Nov  9 2010 Lionel Cons <lionel.cons@cern.ch> - 1.0.57-1
- send_to_msg and recv_from_queue now better handle huge message queues.
* Tue Oct 26 2010 Lionel Cons <lionel.cons@cern.ch> - 1.0.56-1
- msg-to-handler is now more lenient wrt timeout errors.
* Thu Oct  7 2010 Lionel Cons <lionel.cons@cern.ch> - 1.0.55-1
- msg-to-handler.chk now restarts msg-to-handler even if it has been cleanly stopped.
- msg-to-handler better handles broker unavailability (no spurious error).
* Fri Sep 17 2010 Lionel Cons <lionel.cons@cern.ch> - 1.0.54-1
- Yet more code cleanup; no functionality changes.
* Thu Aug 19 2010 Lionel Cons <lionel.cons@cern.ch> - 1.0.53-1
- msg-to-handler now adds an expiration header to error messages.
* Tue Aug 17 2010 Lionel Cons <lionel.cons@cern.ch> - 1.0.52-1
- msg-to-handler now sends messages that triggered errors to a dedicated queue.
* Fri Aug 13 2010 Lionel Cons <lionel.cons@cern.ch> - 1.0.51-1
- Code cleanup and now using the TOM modules.
- handle_service_check and recv_from_queue now use the new
  message queue (MIG::Message::Queue).
* Wed Aug 11 2010 Lionel Cons <lionel.cons@cern.ch> - 1.0.50-1
- Added a -ping option to msg-to-handler to probe the STOMP connection.
* Fri Jul 30 2010 Lionel Cons <lionel.cons@cern.ch> - 1.0.49-1
- Started to use the new queues using the new Directory::Queue module.
- Better error handling in the Nagios handlers and plugins.
* Tue Jun 29 2010 Emir <eimamagi@srce.hr> 1.0.48-1
- Fixed url_help should be empty if SERVICENOTESURL is empty
  https://tomtools.cern.ch/jira/browse/MIG-122
* Thu Jun 17 2010 James Casey <james.casey@cern.ch> 1.0.47-1
- Bugfixes
* Mon Jun 07 2010 Lionel Cons <lionel.cons@cern.ch> - 1.0.46-1
- Added hourly cron job to check and eventually restart msg-to-handler.
* Wed Jun 02 2010 Lionel Cons <lionel.cons@cern.ch> - 1.0.45-2
- Configuration files not flagged as "noreplace" anymore.
* Wed Jun 02 2010 Lionel Cons <lionel.cons@cern.ch> - 1.0.45-1
- Removed deadlock in msg-to-handler and added remote monitoring.
* Mon May 10 2010 Lionel Cons <lionel.cons@cern.ch> - 1.0.44-1
- Fixed stability problems in msg-to-handler
* Mon May 03 2010 Lionel Cons <lionel.cons@cern.ch> - 1.0.43-1
- Added msg-to-handler (replacing msg-to-queue)
* Tue Apr 14 2010 Emir <eimamagi@srce.hr> 1.0.42-1
- Added vo_fqan to MetricOutput
  https://savannah.cern.ch/bugs/?64883
* Tue Mar 30 2010 Romain Wartel <Romain.Wartel@cern.ch> 1.0.41-1
- Uninitialised value fix for nagios-notifications
  https://savannah.cern.ch/bugs/?64843
* Tue Mar 23 2010 Lionel Cons <lionel.cons@cern.ch> - 1.0.40-1
- Improved send_to_msg to report the broker it connected to,
  this fixes https://savannah.cern.ch/bugs/?64729
* Fri Mar 19 2010 James Casey <james.casey@cern.ch> 1.0.39-1
- Fix one last problem found in validation with capitalization 
  of headers
* Fri Mar 19 2010 Lionel Cons <lionel.cons@cern.ch> - 1.0.38-1
- Improved send_to_msg to move undelivered messages to a separate queue,
  this fixes https://savannah.cern.ch/bugs/?64350
* Wed Mar 17 2010 Emir <eimamagi@srce.hr> 1.0.37-1
- Filter soft states (https://savannah.cern.ch/bugs/?64428)
- Fix the problem with nagios_host header being sent causing problems
* Tue Mar 16 2010 Romain <Romain.Wartel@cern.ch> 1.0.36-1
- Bugfix + added dry-run mode to resend notifications sent to the MSG
* Fri Mar 12 2010 James Casey <james.casey@cern.ch> 1.0.35-1
- Fix for bug #63281: Provide way to define which nagios is used as definitive for a ROC 
- We now send headers ROC/Role/Nagios_host for all metrics and notifications
* Fri Mar  5 2010 Lionel Cons <lionel.cons@cern.ch> - 1.0.34-1
- Now use Net::STOMP::Client instead of GridMon::MsgBroker (and Net::Stomp)
- Removed: msg-to-handler, check_config_amq, handle_service_check_amq,
  handle_service_change_amq, test_local_broker, flush_dirqueue_msg
* Fri Feb 26 2010 James Casey <james.casey@cern.ch> 1.0.33-1
- [bug #63514] use nagios ROC variable in handle_service_check for msg dests
* Fri Feb 26 2010 Romain <Romain.Wartel@cern.ch> 1.0.32-1
- Added script to list and/or resend notifications sent to the MSG
* Wed Feb 24 2010 Romain <Romain.Wartel@cern.ch> 1.0.31-1
- Added ACK for Dashboard notifications
* Fri Jan 29 2010 Romain <Romain.Wartel@cern.ch> 1.0.30-1
- Added ServiceFlavour for Dashboard notifications
* Tue Jan 19 2010 Romain <Romain.Wartel@cern.ch> 1.0.29-1
- Updated the urlToHelp and urlToHistory values
* Tue Jan 19 2010 Romain <Romain.Wartel@cern.ch> 1.0.28-1
- Adding initial support for MyEGEE "GGUS notifications"
* Fri Jan 08 2010 Romain <Romain.Wartel@cern.ch> 1.0.27-1
- Added support for Dashboard notification IDs
* Tue Nov 17 2009 Romain <Romain.Wartel@cern.ch> 1.0.26-1
- Adding support for error frames, requesting ack for messages
* Fri Nov 13 2009 Romain <Romain.Wartel@cern.ch> 1.0.25-1
- Addressing an issue with the destination configuration
* Thu Nov 11 2009 Romain <Romain.Wartel@cern.ch> 1.0.24-1
- Enabling arbitrary headers modification for alarms
* Tue Nov 10 2009 Steve <steve.traylen@cern.ch> 1.0.23-1
- Change in notifications format.
  https://savannah.cern.ch/bugs/?58222
* Wed Nov 3 2009 Steve <steve.traylen@cern.ch> 1.0.22-1
- Add /topic as prefix to grid.probe.notification.
* Thu Oct 29 2009 Steve <steve.traylen@cern.ch> 1.0.21-2
- Exit scriptlets true whatever.
* Thu Oct 29 2009 Steve <steve.traylen@cern.ch> 1.0.21-1
- Handle_service change dies silently
  https://savannah.cern.ch/bugs/index.php?57696
* Thu Oct 15 2009 Emir <eimamagi@srce.hr> 1.0.20-1
  Added interface to GGUS (https://savannah.cern.ch/bugs/?57109).
* Thu Oct 15 2009 Emir <eimamagi@srce.hr> 1.0.19-1
- Corrected setting env variables (MSG_TO_HANDLER|QUEUE_DESTINATION)
- Corrected patch.
- Changed spool folder from db-nagios-bridge to nagios2metricstore
- Added --local-metric-store parameter for storing results to local metric result store.
- Fixed https://savannah.cern.ch/bugs/?56684
* Thu Sep 17 2009 James Casey <james.casey@cern.ch> 1.0.18-1
- changed local broker queue names in the _amq handlers
*  Tue Sep 15 2009 Emir <eimamagi@srce.hr> 1.0.17-1
- Fixed unsubscribe procedures.
- Implemented SIGPIPE handler for errors in Net::Stomp.
*  Mon Aug 31 2009 Steve <steve.traylen@cern.ch> 1.0.16-1
-  Added handle_service_check_amq, handle_service_change_amq,
   check_config_amq, flush_dirqueue, test_local_broker.
   Added msg-to-handler deamon.
   https://savannah.cern.ch/bugs/?55074
*  Wed Jul 8 2009 Emir <eimamagi@srce.hr> 1.0.15-2%{?dist}
- Added service restart to package postinstall.
*  Wed Jul 8 2009 Emir <eimamagi@srce.hr> 1.0.15-1%{?dist}
- Cosmetic change: rename field "serviceFlavor" to "serviceFlavour" in order
  to keep naming consistence with ATP DB, new MDDB and Metric Store.
*  Tue Jul 7 2009 Emir <eimamagi@srce.hr> 1.0.14-1%{?dist}
- Added serviceType.
*  Mon Jul 6 2009 Emir <eimamagi@srce.hr> 1.0.13-1%{?dist}
- Switched default verbose to 0.
- Added service flavor and hostname to messages containing published results.
*  Wed Jun 22 2009 Emir <eimamagi@srce.hr> 1.0.12-1%{?dist}
- Corrected handle_service_change to store messages to queue /var/spool/msg-nagios-bridge/outgoing_alarms.
- Added directory /var/spool/msg-nagios-bridge/outgoing_alarms.
- SendToMsg is Nagios::Plugin compliant.
- Added timeout signal handlers to SendToMsg.
- Added performance data to SendToMsg.
- Added publishing alarms from handle_service_change queue to SendToMsg.
- Added notification handler (https://savannah.cern.ch/bugs/index.php?52325).
- Fixed send_to_msg.
- Implemented unsubscribing and disconnecting in case of TERM signal and connection failure (msg-to-queue).
*  Wed Jun 22 2009 Emir <eimamagi@srce.hr> 1.0.11-2%{?dist}
- Add check_config to .spec file.
*  Wed Jun 10 2009 Emir <eimamagi@srce.hr> 1.0.11-1%{?dist}
- Bug fix:
  https://savannah.cern.ch/bugs/?51602
*  Tue Jun 09 2009 Emir <eimamagi@srce.hr> 1.0.10-1%{?dist}
- Improved reconnecting procedure in case of connection failure.
- msg-to-queue creates new MsgBroker object and creates new connection.
- Improved behavior when PID file is empty. (https://savannah.cern.ch/bugs/index.php?51159)
- Implemented ConfigCheck which raises WARNING in case new remote configs are available.
- Added better error handling when fetching messages from queue (https://savannah.cern.ch/bugs/index.php?51069)
*  Wed May 27 2009 Emir <eimamagi@srce.hr> 1.0.9-1%{?dist}
- send_to_msg publishes messages both from queue and config cache
- handle_service_check adds role to each message
- msg-to-queue is now modular so that custom number of topics with custom handlers 
   can be used (see example msg-to-queue-site-example.conf)
- for backward compatibility purposes default config for msg-to-queue is
  unique queue for receiving SAM results,
- all configs from directory /etc/msg-to-queue/msg-to-queue.d (directory is part of RPM) are also 
  loaded by default
*  Tue May 06 2009 Emir <eimamagi@srce.hr> 1.0.8-1%{?dist}
- Error messages cleaned up. Daemon is more resilient now
  https://savannah.cern.ch/bugs/index.php?50059
*  Tue May 05 2009 Emir <eimamagi@srce.hr> 1.0.7-1%{?dist}
-  Changed format of details data in passive results.
   https://savannah.cern.ch/bugs/index.php?49834
* Tue Apr 28 2009 Emir <eimamagi@srce.hr> 1.0.6-1
- Added better error handling of STOMP calls.
  https://savannah.cern.ch/bugs/index.php?4965
* Thu Mar 12 2009 James Casey <james.casey@cern.ch> 1.0.5-1
- Fix [bug #47640] Nagios check needed to verify that a broker is configured in cache_file 
- fix bug in usage message
- uses cache_file functionality of GridMon::MsgBroker
* Thu Mar 5 2009 Steve Traylen <steve.traylen@cern.ch> 1.0.4-4
- Add a %{?dist} tag.
* Wed Feb 25 2009 Emir Imamagic <eimamagi@srce.hr> 1.0.4-3
- Added stripping -vo suffix in case when notes are used and vo value is set.
- Added timeout handler to recv_from_queue.
- MultiVO checks published without VO suffix.
- Added support for publishing nagiosName attribute
  (used for multiVO check naming).
- Added support for custom variables in object config
  (alternative to notes).
* Wed Jan 28 2009 Steve Traylen <steve.traylen@cern.ch> 1.0.3-4
- Fixed copy paste/mistake on VERBOSE variable.
* Tue Jan 20 2009 James Casey <james.casey@cern.ch> 1.0.2-4
- New packaging mechanism that does source tarballs too
* Wed Jan 14 2009 Emir Imamagic <eimamagi@srce.hr> 1.0.2-3
- Don't switch on msg-to-queue by default
  (Yaim will do it later)
- Don't overwrite /etc/sysconfig/msg-to-queue.
* Wed Jan 14 2009 Emir Imamagic <eimamagi@srce.hr> 1.0.2-2
- Added init.d script and config for msg-to-queue.
- Added logging to msg-to-queue.
- Added two components MSG2Nagios:
  msg-to-queue - daemon subscribes on topic and report Nagios
  passive results to dir queue
  recv_from_queue - Nagios check gets checks from queue and
  imports them to Nagios as passive checks
- removed obsolete dir structure GridMon
- upped batch limit to 10K.
* Wed Dec 17 2008 James Casey <james.casey@cern.ch> 1.0.1-2
- Changed doc and default for ROLE to 'site'
* Tue Dec 16 2008 James Casey <james.casey@cern.ch> 1.0.1-1
- Updated handle_service_check to use env variabes from nagios to improve
  reliablity
* Mon Dec 01 2008 James Casey <james.casey@cern.ch> 1.0.0-3
- fixed mismatch in names between send_t_mesg and handle_service_check for metadata
* Mon Dec 01 2008 James Casey <james.casey@cern.ch> 1.0.0-1
- moved broker-cache-file to msg-utils package
- Now encodes the 'role' of the nagios into the topic name
- send_to_msg/handle_service_check use metadata to pass through
  role and sitename.
* Mon Nov 10 2008 Steve Traylen <steve.traylen@cern.ch> 0.9.6-1
- Fix  https://savannah.cern.ch/bugs/?43755
  added init.d enabled cron service broker-cache-file. 
* Fri Nov 6 2008 James Casey <james.casey@cern.ch> 0.9.5-1
  - Fix bug #43587: extending 'handle_service_check' OCSP to handle multi-line (details) data from probes
  added --details option to allow to specify a long details string.  Did it this was to be backwards compatible
  - Fix bug #43673: send_to_msg hardcodes broker name to gridmsg102.cern.ch
* Wed Oct 29 2008 James Casey <james.casey@cern.ch> 0.9.4-1
- Fixed bug #43364 : Problem with SendToMsg - subroutine usage_message redefined
* Mon Oct 08 2008 James Casey <james.casey@cern.ch> 0.9.3-1
- removed all GridMon package code to a separate RPM 
* Fri Sep 19 2008 James Casey <james.casey@cern.ch> 0.9.2-1
- added MsgBroker + URI classes
- send_to_msg also implemented
* Tue Sep 16 2008 James Casey <james.casey@cern.ch> 0.9.0-2
- modified tests after adding host/serviceURI
- updated spool [path to be /msg-nagios-bridge/...
- DetailsData now handled correctly
* Tue Sep 16 2008 James Casey <james.casey@cern.ch> 0.9.0-1
- Initial version
